#ifndef __SOFT_IIC__
#define __SOFT_IIC__

#include "sfr62.h"
#include "hardware.h"
/***********************************************
* Edit the port number to suit your hardware. *
***********************************************/
	#define IIC_PORT p7
	#define SCL_PIN p7_5
	#define SCL_PIND pd7_5
	#define SDA_PIN p7_4
	#define SDA_PIND pd7_4


extern unsigned char iic_byte_rx(unsigned char);
extern unsigned char iic_byte_tx(unsigned char);
extern void init_iic(void);

#define SCL SCL_PIN
#define SDA SDA_PIN
#define LOW 0
#define MSb 0x80
#define RX_SCL_STUCK_LOW 1
#define TX_SCL_STUCK_LOW 2
#define START_STUCK_LOW 3
#define STOP_SCL_STUCK_LOW 4
#define SCL_HIZ SCL_PIND = 0
#define SCL_LOW {SCL_PIN = 0; SCL_PIND = 1;}
#define SDA_HIZ SDA_PIND = 0
#define SDA_LOW {SDA_PIN = 0; SDA_PIND = 1;}
/***********************************************************************************
* If you are using a fast core such as M16C or 7700 and need to slow down the IIC *
* bus then uncomment the PAUSE line with the Nops. Although this bloats the code *
* slightly it has a better resolution than "for" or "while" loops. 27 Nops gave *
* an IIC bus speed of 100 kHz on an M16C/20 running at 10MHz (CPU clock = Xin). *
***********************************************************************************/
#define PAUSE { asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
 asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
 asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
 asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
 asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); }

// 44 NOPS
/*********************
* Leave these alone *
*********************/
#define ACK 0
#define NO_ACK 1

unsigned char iic_byte_rx(unsigned char);
unsigned char iic_byte_tx(unsigned char);
void iic_error(unsigned char);
void iic_start(void);
void iic_stop(void);

#endif //__SOF_IIC__